# For more information: https://laravel.com/docs/sail
version: '3'
services:
  nginx-proxy:
    image: nginxproxy/nginx-proxy
    ports:
      - "80:80"
      - "443:443"
    networks:
      - sail
    volumes:
      - ${DOCKER_SOCK_PATH:-/var/run/docker.sock}:/tmp/docker.sock:ro
    healthcheck:
      test: service nginx status || exit 1
      retries: 5
      timeout: 10s

  nginx:
    image: fransys/nginx-for-fpm
    ports:
      - "5000:5000"
    networks:
      - sail
    links:
      - laravel.test
    environment:
      VIRTUAL_HOST: localhost.test
      VIRTUAL_PORT: 5000
    volumes:
      - ${PWD}/.docker/dev/nginx.conf:/etc/nginx/conf.d/default.conf
      - ${PWD}/public:/var/www/html/public
    healthcheck:
      test: service nginx status || exit 1
      retries: 5
      timeout: 10s

  laravel.test:
    build:
      context: .
      dockerfile: .docker/dev/Dockerfile
      args:
        WWWGROUP: '${WWWGROUP}'
        WWWUSER: '${WWWUSER}'
        BUILDKIT_INLINE_CACHE: 1
    image: laravel-demo/app
    environment:
      LOG_CHANNEL: single
    ports:
      - "9000:9000"
    networks:
      - sail
    volumes:
      - ./:/var/www/html
    depends_on:
      - mariadb
      - redis

  mariadb:
    image: mariadb:10.11
    ports:
      - '${FORWARD_DB_PORT:-3306}:3306'
    environment:
      MYSQL_ROOT_PASSWORD: '${DB_PASSWORD}'
      MYSQL_ROOT_HOST: "%"
      MYSQL_DATABASE: '${DB_DATABASE}'
      MYSQL_USER: '${DB_USERNAME}'
      MYSQL_PASSWORD: '${DB_PASSWORD}'
      MYSQL_ALLOW_EMPTY_PASSWORD: 'yes'
    volumes:
      - 'sail-mariadb:/var/lib/mysql'
      - './vendor/laravel/sail/database/mysql/create-testing-database.sh:/docker-entrypoint-initdb.d/10-create-testing-database.sh'
    networks:
      - sail
    healthcheck:
      test: ["CMD", "mysqladmin", "ping", "-p${DB_PASSWORD}"]
      retries: 3
      timeout: 5s

  redis:
    image: redis:7.0.11
    ports:
      - '${FORWARD_REDIS_PORT:-6379}:6379'
    volumes:
      - 'sail-redis:/data'
    networks:
      - sail
    healthcheck:
      test: ["CMD", "redis-cli", "ping"]
      retries: 3
      timeout: 5s


networks:
  sail:
    driver: bridge

volumes:
  sail-mariadb:
    driver: local
  sail-redis:
    driver: local
